﻿@inject ISnackbar Snackbar
@inject UserAppState UserAppState

@inject UserAppState UserAppState

@implements IDisposable

<MudDialog>
    <DialogContent>
        <MudText Typo="Typo.h5">Create Group</MudText>
        <MudText>Specify 0 for a random ID</MudText>
    </DialogContent>
    <DialogActions>
        <MudStack>
            <MudTextField T="int"
                          @bind-Value="@RequestedId"
                          InputType="InputType.Number"
                          Label="Requested ID"
                          Immediate="true"
                          Error="@RequestedIdHasError"
                          ErrorText="@RequestedIdErrorText"
                          Variant="Variant.Outlined">Requested Id</MudTextField>
            <LengthValidatedTextField @bind-Text="@GroupName"
                                      Label="Group Name"
                                      MinLength="3"
                                      MaxLength="16" />
            <MudText>@(Common.Spacer())</MudText>
            <MudStack>
                <MudText Typo="Typo.h6">Group Permissions</MudText>         
                <MudContainer Style="max-height: 500px; overflow-y: scroll">
                    <PermissionTree @bind-Permissions="Perms" />
                </MudContainer>
            </MudStack>
            <MudStack Justify="Justify.FlexEnd" Row="true">
                <MudButton Color="Color.Secondary" Disabled="@IsCreatingGroup" OnClick="OnCancel">Cancel</MudButton>
                <MudButton Color="Color.Primary" Disabled="@CreateButtonDisabled" OnClick="OnCreateGroup">
                @if (IsCreatingGroup)
                {
                    <MudProgressCircular Class="ms-n1" Size="Size.Small" Indeterminate="true" />
                }
                <MudText Class="ms-2">Create</MudText>
                </MudButton>
            </MudStack>
        </MudStack>
    </DialogActions>
</MudDialog>